<template>
  <div class="page-body">

    <vxe-form :data="formOptions.data" ref="xForm" :title-width="formOptions.titleWidth"
      :title-align="formOptions.titleAlign" :rules="formOptions.rules" :items="formOptions.items" titleColon>
      <template #myregion="{}">
        <a-input-search placeholder="input search text" enter-button />
      </template>
    </vxe-form>


    <div class="footerbar">
      <a-button type="primary" @click="ok">确定</a-button>
      <a-button @click="cancel">取消</a-button>
    </div>

  </div>
</template>

<script>
import BASE_URL from '@/services/base/api.js';

export default {
  name: 'AdminUserEdit',
  i18n: require('./i18n'),

  props: {
    pageMode: {
      type: String,
      default: "edit"
    },
    dataId: {
    }

  },

  data() {

    // 页面数据变量
    var pageData = {

      actions: {
        create: `${BASE_URL.BASE_URL}/AdminUser/v1/create`,
        update: `${BASE_URL.BASE_URL}/AdminUser/v1/update`,
        get: `${BASE_URL.BASE_URL}/AdminUser/v1/detail`
      },

      formOptions: {
        data: {
          "name": "",
          "nick_name": "",
          "avatar": "",
          "email": "",
          "mobile": "",
          "password": "",
          "status": 1,
          "is_super": 0,
          "level": 1,
          "token": ""
        },

        titleWidth: 100,
        titleAlign: 'right',

        rules: {
          name: [
            { required: true, message: '请输入名称' }
          ],
          email: [
            {
              validator({ itemValue }) {
                // 自定义校验
                if (itemValue && !/^(\w)+(\.\w+)*@(\w)+((\.\w+)+)$/.test(itemValue)) {
                  return new Error('email格式不正确')
                }
              }
            }
          ],
          mobile: [
            { required: true, message: '请输入手机号' },
            {
              validator({ itemValue }) {
                // 自定义校验
                if (itemValue && !/^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/.test(itemValue)) {
                  return new Error('手机号格式不正确')
                }
              }
            }
          ],
        },

        items: [
          {
            title: '左侧',
            children: [
              { field: 'name', title: '名称', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入名称' } } },
              { field: 'mobile', title: '联系电话', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入联系电话' } } },
              { field: 'nick_name', title: '昵称', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入昵称' } } },
              { field: 'email', title: 'email', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入email' } } }
            ]
          }
        ]
      }

    };

    pageData.formOptions = Object.assign({}, this.$mk.config.defaults.formOptions, pageData.formOptions);

    return pageData;
  }, 
  created() {
    if (this.dataId) {
      this.$mk.post({
        url: this.actions.get,
        loading: "加载中...",
        data: {
          id: this.dataId
        }
      }).then(a => {
        this.formOptions.data = a.data.AdminUser;
      }).catch((a) => {
        this.$mk.error(a.data.msg);
      });
    }

  },
  // 函数
  methods: {


    loadData() {
    },

    ok() {

      let save = () => {
        let action = this.pageMode == "add" ? this.actions.create : this.actions.update;
        let postdata = this.pageMode == "add" ? Object.assign({ id: this.dataId }, this.formOptions.data) : Object.assign({}, this.formOptions.data);

        if (this.pageMode == "add") {
          postdata.password = "123456";
        }
        this.$mk.post({
          url: action,
          loading: "保存中...",
          data: postdata
        }).then(() => {
          this.$mk.success("保存成功");
          this.$emit("callback", { success: true });
        }).catch((a) => {
          this.$mk.error(a.data.msg);
        });
      };

      this.$refs.xForm.validate((a) => {

        if (a) {
          let count = 0;
          for (let name in a) {
            a[name];
            count++;
          }
          this.$mk.error(`存在${count}项错误，请检查`);
        } else {
          save();
        }
      });


    },

    cancel() {
      this.$emit("callback", {});
    }
  },
  // 监听属性
  watch: {

  }
};

</script>
<style>

</style>
